﻿#include <stdio.h>
#include <pthread.h>

#define MAX_CHEESE 100

typedef struct {
    int* cheese_count;
    pthread_mutex_t* mutex;
} ThreadData;

//  ВАЖНО: Правильная сигнатура функции для pthread
void* producer(void* arg) {  // ✅ void* возврат и аргумент
    ThreadData* data = (ThreadData*)arg;
    for (int i = 0; i < 50; i++) {
        pthread_mutex_lock(data->mutex);
        (*data->cheese_count)++;
        pthread_mutex_unlock(data->mutex);
    }
    return NULL;
}

int main() {
    int cheese_count = 0;
    pthread_mutex_t mutex;
    pthread_mutex_init(&mutex, NULL);

    ThreadData data = { &cheese_count, &mutex };
    pthread_t t1, t2;

    // Передаём producer БЕЗ скобок и аргументов
    if (pthread_create(&t1, NULL, producer, &data) != 0 ||
        pthread_create(&t2, NULL, producer, &data) != 0) {
        perror("pthread_create");
        return 1;
    }

    pthread_join(t1, NULL);
    pthread_join(t2, NULL);

    printf("%.1f\n", (float)cheese_count);
    pthread_mutex_destroy(&mutex);
    return 0;
}