﻿#include <stdio.h>
#include <stddef.h>
#include <stdalign.h>

#define MEM_SIZE 4096

typedef struct {
    char memory[MEM_SIZE];
    size_t offset;
} MemoryManager;

void* mm_alloc(MemoryManager* manager, size_t size) {  // Указатель!
    size_t alignment = alignof(int);
    size_t padding = (alignment - (manager->offset % alignment)) % alignment;

    if (manager->offset + padding + size > MEM_SIZE) return NULL;
    manager->offset += padding;

    void* ptr = &manager->memory[manager->offset];
    manager->offset += size;
    return ptr;
}

int main() {
    MemoryManager manager = { .offset = 0 };
    int* arr = mm_alloc(&manager, 10 * sizeof(int));  // Исправлено

    if (!arr) {
        fprintf(stderr, "Allocation failed\n");
        return 1;
    }

    for (int i = 0; i < 10; i++) {
        printf(i == 9 ? "%d" : "%d ", arr[i]);
    }
    printf("\n");
    return 0;
}
