#define LED 13
#define BUTTON 2
static unsigned long lastDebounceTime = 0;
static const unsigned long debounceDelay = 50;

void setup() {
    pinMode(LED, OUTPUT);
    pinMode(BUTTON, INPUT_PULLUP);
    Serial.begin(9600);
}

// cppcheck-suppress unusedFunction
void loop() {
    int reading = digitalRead(BUTTON);

    if (reading == LOW && (millis() - lastDebounceTime) > debounceDelay) {
        digitalWrite(LED, HIGH);
        Serial.println("Button pressed!");
        delay(100);
        digitalWrite(LED, LOW);
        lastDebounceTime = millis();
    }
}
